/********************************************************************
  ROME.h, M. Schneebeli PSI

  $Id: ROME.h 1616 2007-01-02 12:27:56Z sawada $

********************************************************************/
#ifndef ROME_H
#define ROME_H
#include <Rtypes.h>

#define THREADRETURN NULL
#define THREADTYPE void*

#if defined( R__VISUAL_CPLUSPLUS )
#   define OS_WINNT
#endif

#if defined( OS_WINNT ) && defined( ROMEDLL_EXPORTS )
#   define DLLEXPORT __declspec(dllexport)
#else
#   define DLLEXPORT
#endif

#ifdef R__GNU
#   define SafeDeleteArray(p) { if (p) { delete [] p; p = 0; } }
#else
#   define SafeDeleteArray(p) { delete [] p; p = 0; }
#endif

#if defined(R__GNU) && !defined(__MAKECINT__)
#   define G_GNUC_PRINTF( format_idx, arg_idx )                 \
   __attribute__((format (printf, format_idx, arg_idx)))
#   define G_GNUC_SCANF( format_idx, arg_idx )          \
   __attribute__((format (scanf, format_idx, arg_idx)))
#   define G_GNUC_FORMAT( arg_idx )             \
   __attribute__((format_arg (arg_idx)))
#else
#   define G_GNUC_PRINTF( format_idx, arg_idx )
#   define G_GNUC_SCANF( format_idx, arg_idx )
#   define G_GNUC_FORMAT( arg_idx )
#endif

#define WarningSuppression(x) { if (x) { int warning_suppression; warning_suppression = 0; } }

// This macro can be used for debugging like,
//  void test(int i)
//  {
//     if(i != 3) dbgprintf("i=%d", i);
//  }
#if defined( R__VISUAL_CPLUSPLUS )
//#   define dbgprintf(...) (printf("%s:%u in %s:",__FILE__,__LINE__,__FUNCTION__),printf(" "__VA_ARGS__))
#else
#   define dbgprintf(...) (printf("%s:%u in %s:",__FILE__,__LINE__,__func__),printf(" "__VA_ARGS__))
#endif

#endif   // ROME_H

